;---------------------------------------------------------------------
      use32              ; включить 32-битный режим ассемблера
      org    0           ; адресация с нуля
     
      db     'MENUET01'  ; 8-байтный идентификатор MenuetOS
      dd     1           ; версия заголовка (1 либо 2, см. док-ю)
      dd     START       ; адрес первой команды
      dd     I_END       ; размер программы
      dd    MEM         ; количество памяти
      dd    0    ; 
      dd     0      ; адрес буфера для параметров командн. строки
      dd     0          ;  Path Icon image

    include "macros.inc" ; макросы облегчают жизнь ассемблерщиков!

     include "masm.inc"
	 include "proc32.inc"
	 
START:	
; Функция 75, подфункция 0, Открыть сокет.  

	 ; Параметры:
  ; * eax = 75 - номер функции
  ; * bl = 0 - номер подфункции
  ; * ecx = домен
  ; * edx = тип
  ; * esi = протокол
; Возвращаемое значение:
  ; * eax = номер сокета, -1 для ошибки
  ; * ebx = код ошибки
 
 
.j2:
 ; AF_INET4        = 2     ; IPv4 
; SOCK_STREAM     = 1	 
mcall 75,0,2,1,0 ;[Protocol]
test eax,eax
jg .j1
int3
nop
.j1:
mov ecx,eax

mcall 5,1

; Функция 75, подфункция 1, Закрыть сокет.   
	 
; Параметры:
  ; * eax = 75 - номер функции
  ; * bl = 1 - номер подфункции
  ; * ecx = номер сокета
; Возвращаемое значение:
  ; * eax = -1 для ошибки
  ; * ebx = код ошибки

mcall 75,1, ,
test eax,eax
jge .j2
int3
nop
jmp .j2 

  
 I_END:                  ; метка конца программы
	
      rb 4096               ; память для стека
    align 16
    STACKTOP:               ; метка вершины стека 


    MEM:                    ; метка указывающая на конец программы плюс
